SystemOrganization addCategory: #'Phidget-Examples'!

Object subclass: #PhdExIfKitLED
	instanceVariableNames: 'ifKit running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Examples'!

!PhdExIfKitLED commentStamp: 'pt 6/30/2009 11:55' prior: 0!
This is an example for the usage of an InterfaceKit (ifKit).
We expect that there are LED connected to the digital output of the ifKit.

execute this in a workspace:
	led := PhdExIfKitLED new. "creates a new LEDExample"
	led start.				"starts the animation"
	led stop.				"stops the animation"!

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:12'!
initialize

	super initialize.
	ifKit := PhdCrInterfaceKit new.! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:38'!
process
	[running] whileTrue: [
		ifKit outputs size = 0 ifFalse: [
			self setLEDState].
		(Delay forMilliseconds: self waitTime) wait]! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:45'!
setLEDState
	self toggle: {(1 to: ifKit outputs size) atRandom}.! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:29'!
start
	ifKit openAny.
	running := true.
	[self process] fork.! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:54'!
stop
	running := false.
	self turnAllOff.
	ifKit close.! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:45'!
toggle: anArray
	anArray do: [: i |
		(ifKit outputs at: i) value: (ifKit outputs at: i) value not]! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:43'!
turnAllOff
	(1 to: ifKit outputs size) do: [:i | (ifKit outputs at: i) value: false].! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:42'!
turnOff: anArray
	anArray do: [:i | (ifKit outputs at: i) value: false].! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:42'!
turnOn: anArray
	anArray do: [:i | (ifKit outputs at: i) value: true].! !

!PhdExIfKitLED methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:54'!
waitTime
	^ 500! !

PhdExIfKitLED subclass: #PhdExIfKitLEDSpiral
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Examples'!

!PhdExIfKitLEDSpiral commentStamp: 'pt 6/30/2009 12:00' prior: 0!
This class expects the LED ordered as the following:
    4
    3
8 7   6 5
    2
    1
!

!PhdExIfKitLEDSpiral methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:01'!
initialize
	super initialize.
	state := #1.! !

!PhdExIfKitLEDSpiral methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:05'!
setLEDState
	
	state =  1 ifTrue: [self turnOn: {1.}. state :=  2. ^ self].
	state =  2 ifTrue: [self turnOn: {8.}. state :=  3. ^ self].
	state =  3 ifTrue: [self turnOn: {4.}. state :=  4. ^ self].
	state =  4 ifTrue: [self turnOn: {5.}. state :=  5. ^ self].
	state =  5 ifTrue: [self turnOn: {2.}. state :=  6. ^ self].
	state =  6 ifTrue: [self turnOn: {7.}. state :=  7. ^ self].
	state =  7 ifTrue: [self turnOn: {3.}. state :=  8. ^ self].
	state =  8 ifTrue: [self turnOn: {6.}. state :=  9. ^ self].
	
	state =  9 ifTrue: [self turnOff: {1.}. state := 10. ^ self].
	state = 10 ifTrue: [self turnOff: {8.}. state := 11. ^ self].
	state = 11 ifTrue: [self turnOff: {4.}. state := 12. ^ self].
	state = 12 ifTrue: [self turnOff: {5.}. state := 13. ^ self].
	state = 13 ifTrue: [self turnOff: {2.}. state := 14. ^ self].
	state = 14 ifTrue: [self turnOff: {7.}. state := 15. ^ self].
	state = 15 ifTrue: [self turnOff: {3.}. state := 16. ^ self].
	state = 16 ifTrue: [self turnOff: {6.}. state :=  1. ^ self].! !

!PhdExIfKitLEDSpiral methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 12:06'!
waitTime
	^ 100! !

PhdExIfKitLED subclass: #PhdExIfKitLEDToggle
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Examples'!

!PhdExIfKitLEDToggle methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:51'!
initialize
	super initialize.
	state := #1.! !

!PhdExIfKitLEDToggle methodsFor: 'as yet unclassified' stamp: 'pt 6/30/2009 11:53'!
setLEDState
	self turnAllOff.
	state = #1 ifTrue: [self turnOn: {1. 2. 3. 4.}. state := 2. ^ self].
	state = #2 ifTrue: [self turnOn: {5. 6. 7. 8.}. state := 1. ^ self].! !
